from threading import Condition

class RWLock:
    def __init__(self):
        self.readings=0
        self.writing=0
        self.waiting=0
        self.freedom=Condition()
    def acquire(self,mode):
        self.freedom.acquire()
        if mode=='r':
            while self.writing or self.waiting:
                self.freedom.wait()
            self.readings=self.readings+1
        elif mode=='w':
            while self.writing or self.readings:
                self.waiting=self.waiting+1
                self.freedom.wait()
                self.waiting=self.waiting-1
            self.writing=1
        else:
            self.freedom.release()
            raise ValueError
        self.freedom.release()
    def release(self,mode):
        self.freedom.acquire()
        if mode=='r':
            if self.readings:
                self.readings=self.readings-1
                if self.readings==0:
                    self.freedom.notify()
            else:
                self.freedom.release()
                raise ValueError
        elif mode=='w':
            if self.writing:
                self.writing=0
                self.freedom.notifyAll()
            else:
                self.freedom.release()
                raise ValueError
        else:
            self.freedom.release()
            raise ValueError
        self.freedom.release()

